<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>32.8. tabnanny — Detection of ambiguous indentation &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="32. Python Language Services" href="language.html" />
    <link rel="next" title="32.9. pyclbr — Python class browser support" href="pyclbr.html" />
    <link rel="prev" title="32.7. tokenize — Tokenizer for Python source" href="tokenize.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pyclbr.html" title="32.9. pyclbr — Python class browser support"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="tokenize.html" title="32.7. tokenize — Tokenizer for Python source"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="language.html" accesskey="U">32. Python Language Services</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-tabnanny">
<span id="tabnanny-detection-of-ambiguous-indentation"></span><h1>32.8. <a class="reference internal" href="#module-tabnanny" title="tabnanny: Tool for detecting white space related problems in Python source files in a directory tree."><code class="xref py py-mod docutils literal"><span class="pre">tabnanny</span></code></a> &#8212; Detection of ambiguous indentation<a class="headerlink" href="#module-tabnanny" title="Permalink to this headline">¶</a></h1>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/tabnanny.py">Lib/tabnanny.py</a></p>
<hr class="docutils" />
<p>For the time being this module is intended to be called as a script. However it
is possible to import it into an IDE and use the function <a class="reference internal" href="#tabnanny.check" title="tabnanny.check"><code class="xref py py-func docutils literal"><span class="pre">check()</span></code></a>
described below.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The API provided by this module is likely to change in future releases; such
changes may not be backward compatible.</p>
</div>
<dl class="function">
<dt id="tabnanny.check">
<code class="descclassname">tabnanny.</code><code class="descname">check</code><span class="sig-paren">(</span><em>file_or_dir</em><span class="sig-paren">)</span><a class="headerlink" href="#tabnanny.check" title="Permalink to this definition">¶</a></dt>
<dd><p>If <em>file_or_dir</em> is a directory and not a symbolic link, then recursively
descend the directory tree named by <em>file_or_dir</em>, checking all <code class="file docutils literal"><span class="pre">.py</span></code>
files along the way.  If <em>file_or_dir</em> is an ordinary Python source file, it
is checked for whitespace related problems.  The diagnostic messages are
written to standard output using the <a class="reference internal" href="functions.html#print" title="print"><code class="xref py py-func docutils literal"><span class="pre">print()</span></code></a> function.</p>
</dd></dl>

<dl class="data">
<dt id="tabnanny.verbose">
<code class="descclassname">tabnanny.</code><code class="descname">verbose</code><a class="headerlink" href="#tabnanny.verbose" title="Permalink to this definition">¶</a></dt>
<dd><p>Flag indicating whether to print verbose messages. This is incremented by the
<code class="docutils literal"><span class="pre">-v</span></code> option if called as a script.</p>
</dd></dl>

<dl class="data">
<dt id="tabnanny.filename_only">
<code class="descclassname">tabnanny.</code><code class="descname">filename_only</code><a class="headerlink" href="#tabnanny.filename_only" title="Permalink to this definition">¶</a></dt>
<dd><p>Flag indicating whether to print only the filenames of files containing
whitespace related problems.  This is set to true by the <code class="docutils literal"><span class="pre">-q</span></code> option if called
as a script.</p>
</dd></dl>

<dl class="exception">
<dt id="tabnanny.NannyNag">
<em class="property">exception </em><code class="descclassname">tabnanny.</code><code class="descname">NannyNag</code><a class="headerlink" href="#tabnanny.NannyNag" title="Permalink to this definition">¶</a></dt>
<dd><p>Raised by <a class="reference internal" href="#tabnanny.tokeneater" title="tabnanny.tokeneater"><code class="xref py py-func docutils literal"><span class="pre">tokeneater()</span></code></a> if detecting an ambiguous indent. Captured and
handled in <a class="reference internal" href="#tabnanny.check" title="tabnanny.check"><code class="xref py py-func docutils literal"><span class="pre">check()</span></code></a>.</p>
</dd></dl>

<dl class="function">
<dt id="tabnanny.tokeneater">
<code class="descclassname">tabnanny.</code><code class="descname">tokeneater</code><span class="sig-paren">(</span><em>type</em>, <em>token</em>, <em>start</em>, <em>end</em>, <em>line</em><span class="sig-paren">)</span><a class="headerlink" href="#tabnanny.tokeneater" title="Permalink to this definition">¶</a></dt>
<dd><p>This function is used by <a class="reference internal" href="#tabnanny.check" title="tabnanny.check"><code class="xref py py-func docutils literal"><span class="pre">check()</span></code></a> as a callback parameter to the function
<a class="reference internal" href="tokenize.html#tokenize.tokenize" title="tokenize.tokenize"><code class="xref py py-func docutils literal"><span class="pre">tokenize.tokenize()</span></code></a>.</p>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="tokenize.html#module-tokenize" title="tokenize: Lexical scanner for Python source code."><code class="xref py py-mod docutils literal"><span class="pre">tokenize</span></code></a></dt>
<dd>Lexical scanner for Python source code.</dd>
</dl>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="tokenize.html"
                        title="previous chapter">32.7. <code class="docutils literal"><span class="pre">tokenize</span></code> &#8212; Tokenizer for Python source</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pyclbr.html"
                        title="next chapter">32.9. <code class="docutils literal"><span class="pre">pyclbr</span></code> &#8212; Python class browser support</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/tabnanny.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pyclbr.html" title="32.9. pyclbr — Python class browser support"
             >next</a> |</li>
        <li class="right" >
          <a href="tokenize.html" title="32.7. tokenize — Tokenizer for Python source"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="language.html" >32. Python Language Services</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>